diff -uwbBpr libfloat/softfloat/bits64/softfloat.c SoftFloat-2a/softfloat/bits64/softfloat.c
--- libfloat/softfloat/bits64/softfloat.c	Wed Sep 15 16:18:52 1999
+++ SoftFloat-2a/softfloat/bits64/softfloat.c	Mon Sep 20 11:47:08 1999
@@ -3,7 +3,7 @@
 ===============================================================================
 
 This C source file is part of the SoftFloat IEC/IEEE Floating-point
-Arithmetic Package, Release 2.
+Arithmetic Package, Release 2a.
 
 Written by John R. Hauser.  This work was made possible in part by the
 International Computer Science Institute, located at Suite 600, 1947 Center
@@ -12,8 +12,8 @@ National Science Foundation under grant 
 of this code was written as part of a project to build a fixed-point vector
 processor in collaboration with the University of California at Berkeley,
 overseen by Profs. Nelson Morgan and John Wawrzynek.  More information
-is available through the web page `http://HTTP.CS.Berkeley.EDU/~jhauser/
-arithmetic/softfloat.html'.
+is available through the Web page `http://HTTP.CS.Berkeley.EDU/~jhauser/
+arithmetic/SoftFloat.html'.
 
 THIS SOFTWARE IS DISTRIBUTED AS IS, FOR FREE.  Although reasonable effort
 has been made to avoid it, THIS SOFTWARE MAY CONTAIN FAULTS THAT WILL AT
@@ -23,7 +23,7 @@ AND ALL LOSSES, COSTS, OR OTHER PROBLEMS
 
 Derivative works are acceptable, even for commercial purposes, so long as
 (1) they include prominent notice that the work is derivative, and (2) they
-include prominent notice akin to these three paragraphs for those parts of
+include prominent notice akin to these four paragraphs for those parts of
 this code that are retained.
 
 ===============================================================================
@@ -39,8 +39,10 @@ and exception flags.
 -------------------------------------------------------------------------------
 */
 int8 float_rounding_mode = float_round_nearest_even;
-int8 floatx80_rounding_precision = 80;
 int8 float_exception_flags = 0;
+#ifdef FLOATX80
+int8 floatx80_rounding_precision = 80;
+#endif
 
 /*
 -------------------------------------------------------------------------------
@@ -67,11 +69,11 @@ specific.
 -------------------------------------------------------------------------------
 Takes a 64-bit fixed-point value `absZ' with binary point between bits 6
 and 7, and returns the properly rounded 32-bit integer corresponding to the
-input.  If `zSign' is nonzero, the input is negated before being converted
-to an integer.  Bit 63 of `absZ' must be zero.  Ordinarily, the fixed-point
-input is simply rounded to an integer, with the inexact exception raised if
-the input cannot be represented exactly as an integer.  If the fixed-point
-input is too large, however, the invalid exception is raised and the largest
+input.  If `zSign' is 1, the input is negated before being converted to an
+integer.  Bit 63 of `absZ' must be zero.  Ordinarily, the fixed-point input
+is simply rounded to an integer, with the inexact exception raised if the
+input cannot be represented exactly as an integer.  However, if the fixed-
+point input is too large, the invalid exception is raised and the largest
 positive or negative integer is returned.
 -------------------------------------------------------------------------------
 */
@@ -105,8 +107,8 @@ static int32 roundAndPackInt32( flag zSi
     z = absZ;
     if ( zSign ) z = - z;
     if ( ( absZ>>32 ) || ( z && ( ( z < 0 ) ^ zSign ) ) ) {
-        float_exception_flags |= float_flag_invalid;
-        return zSign ? 0x80000000 : 0x7FFFFFFF;
+        float_raise( float_flag_invalid );
+        return zSign ? (sbits32) 0x80000000 : 0x7FFFFFFF;
     }
     if ( roundBits ) float_exception_flags |= float_flag_inexact;
     return z;
@@ -115,6 +117,60 @@ static int32 roundAndPackInt32( flag zSi
 
 /*
 -------------------------------------------------------------------------------
+Takes the 128-bit fixed-point value formed by concatenating `absZ0' and
+`absZ1', with binary point between bits 63 and 64 (between the input words),
+and returns the properly rounded 64-bit integer corresponding to the input.
+If `zSign' is 1, the input is negated before being converted to an integer.
+Ordinarily, the fixed-point input is simply rounded to an integer, with
+the inexact exception raised if the input cannot be represented exactly as
+an integer.  However, if the fixed-point input is too large, the invalid
+exception is raised and the largest positive or negative integer is
+returned.
+-------------------------------------------------------------------------------
+*/
+static int64 roundAndPackInt64( flag zSign, bits64 absZ0, bits64 absZ1 )
+{
+    int8 roundingMode;
+    flag roundNearestEven, increment;
+    int64 z;
+
+    roundingMode = float_rounding_mode;
+    roundNearestEven = ( roundingMode == float_round_nearest_even );
+    increment = ( (sbits64) absZ1 < 0 );
+    if ( ! roundNearestEven ) {
+        if ( roundingMode == float_round_to_zero ) {
+            increment = 0;
+        }
+        else {
+            if ( zSign ) {
+                increment = ( roundingMode == float_round_down ) && absZ1;
+            }
+            else {
+                increment = ( roundingMode == float_round_up ) && absZ1;
+            }
+        }
+    }
+    if ( increment ) {
+        ++absZ0;
+        if ( absZ0 == 0 ) goto overflow;
+        absZ0 &= ~ ( ( (bits64) ( absZ1<<1 ) == 0 ) & roundNearestEven );
+    }
+    z = absZ0;
+    if ( zSign ) z = - z;
+    if ( z && ( ( z < 0 ) ^ zSign ) ) {
+ overflow:
+        float_raise( float_flag_invalid );
+        return
+              zSign ? (sbits64) LIT64( 0x8000000000000000 )
+            : LIT64( 0x7FFFFFFFFFFFFFFF );
+    }
+    if ( absZ1 ) float_exception_flags |= float_flag_inexact;
+    return z;
+
+}
+
+/*
+-------------------------------------------------------------------------------
 Returns the fraction bits of the single-precision floating-point value `a'.
 -------------------------------------------------------------------------------
 */
@@ -194,7 +250,7 @@ and significand `zSig', and returns the 
 point value corresponding to the abstract input.  Ordinarily, the abstract
 value is simply rounded and packed into the single-precision format, with
 the inexact exception raised if the abstract input cannot be represented
-exactly.  If the abstract value is too large, however, the overflow and
+exactly.  However, if the abstract value is too large, the overflow and
 inexact exceptions are raised and an infinity or maximal finite value is
 returned.  If the abstract value is too small, the input value is rounded to
 a subnormal number, and the underflow and inexact exceptions are raised if
@@ -207,7 +263,7 @@ significand must be normalized or smalle
 and it must not require rounding.  In the usual case that `zSig' is
 normalized, `zExp' must be 1 less than the ``true'' floating-point exponent.
 The handling of underflow and overflow follows the IEC/IEEE Standard for
-Binary Floating-point Arithmetic.
+Binary Floating-Point Arithmetic.
 -------------------------------------------------------------------------------
 */
 static float32 roundAndPackFloat32( flag zSign, int16 zExp, bits32 zSig )
@@ -267,9 +323,9 @@ static float32 roundAndPackFloat32( flag
 Takes an abstract floating-point value having sign `zSign', exponent `zExp',
 and significand `zSig', and returns the proper single-precision floating-
 point value corresponding to the abstract input.  This routine is just like
-`roundAndPackFloat32' except that `zSig' does not have to be normalized in
-any way.  In all cases, `zExp' must be 1 less than the ``true'' floating-
-point exponent.
+`roundAndPackFloat32' except that `zSig' does not have to be normalized.
+Bit 31 of `zSig' must be zero, and `zExp' must be 1 less than the ``true''
+floating-point exponent.
 -------------------------------------------------------------------------------
 */
 static float32
@@ -363,7 +419,7 @@ and significand `zSig', and returns the 
 point value corresponding to the abstract input.  Ordinarily, the abstract
 value is simply rounded and packed into the double-precision format, with
 the inexact exception raised if the abstract input cannot be represented
-exactly.  If the abstract value is too large, however, the overflow and
+exactly.  However, if the abstract value is too large, the overflow and
 inexact exceptions are raised and an infinity or maximal finite value is
 returned.  If the abstract value is too small, the input value is rounded to
 a subnormal number, and the underflow and inexact exceptions are raised if
@@ -376,7 +432,7 @@ significand must be normalized or smalle
 and it must not require rounding.  In the usual case that `zSig' is
 normalized, `zExp' must be 1 less than the ``true'' floating-point exponent.
 The handling of underflow and overflow follows the IEC/IEEE Standard for
-Binary Floating-point Arithmetic.
+Binary Floating-Point Arithmetic.
 -------------------------------------------------------------------------------
 */
 static float64 roundAndPackFloat64( flag zSign, int16 zExp, bits64 zSig )
@@ -436,9 +492,9 @@ static float64 roundAndPackFloat64( flag
 Takes an abstract floating-point value having sign `zSign', exponent `zExp',
 and significand `zSig', and returns the proper double-precision floating-
 point value corresponding to the abstract input.  This routine is just like
-`roundAndPackFloat64' except that `zSig' does not have to be normalized in
-any way.  In all cases, `zExp' must be 1 less than the ``true'' floating-
-point exponent.
+`roundAndPackFloat64' except that `zSig' does not have to be normalized.
+Bit 63 of `zSig' must be zero, and `zExp' must be 1 less than the ``true''
+floating-point exponent.
 -------------------------------------------------------------------------------
 */
 static float64
@@ -535,7 +591,7 @@ and returns the proper extended double-p
 corresponding to the abstract input.  Ordinarily, the abstract value is
 rounded and packed into the extended double-precision format, with the
 inexact exception raised if the abstract input cannot be represented
-exactly.  If the abstract value is too large, however, the overflow and
+exactly.  However, if the abstract value is too large, the overflow and
 inexact exceptions are raised and an infinity or maximal finite value is
 returned.  If the abstract value is too small, the input value is rounded to
 a subnormal number, and the underflow and inexact exceptions are raised if
@@ -549,7 +605,7 @@ format.
 significand is not normalized, `zExp' must be 0; in that case, the result
 returned is a subnormal number, and it must not require rounding.  The
 handling of underflow and overflow follows the IEC/IEEE Standard for Binary
-Floating-point Arithmetic.
+Floating-Point Arithmetic.
 -------------------------------------------------------------------------------
 */
 static floatx80
@@ -686,7 +742,8 @@ static floatx80
             }
             if ( increment ) {
                 ++zSig0;
-                zSig0 &= ~ ( ( zSig1 + zSig1 == 0 ) & roundNearestEven );
+                zSig0 &=
+                    ~ ( ( (bits64) ( zSig1<<1 ) == 0 ) & roundNearestEven );
                 if ( (sbits64) zSig0 < 0 ) zExp = 1;
             }
             return packFloatx80( zSign, zExp, zSig0 );
@@ -700,7 +757,7 @@ static floatx80
             zSig0 = LIT64( 0x8000000000000000 );
         }
         else {
-            zSig0 &= ~ ( ( zSig1 + zSig1 == 0 ) & roundNearestEven );
+            zSig0 &= ~ ( ( (bits64) ( zSig1<<1 ) == 0 ) & roundNearestEven );
         }
     }
     else {
@@ -870,7 +927,7 @@ and `zSig2', and returns the proper quad
 corresponding to the abstract input.  Ordinarily, the abstract value is
 simply rounded and packed into the quadruple-precision format, with the
 inexact exception raised if the abstract input cannot be represented
-exactly.  If the abstract value is too large, however, the overflow and
+exactly.  However, if the abstract value is too large, the overflow and
 inexact exceptions are raised and an infinity or maximal finite value is
 returned.  If the abstract value is too small, the input value is rounded to
 a subnormal number, and the underflow and inexact exceptions are raised if
@@ -881,7 +938,7 @@ significand is not normalized, `zExp' mu
 returned is a subnormal number, and it must not require rounding.  In the
 usual case that the input significand is normalized, `zExp' must be 1 less
 than the ``true'' floating-point exponent.  The handling of underflow and
-overflow follows the IEC/IEEE Standard for Binary Floating-point Arithmetic.
+overflow follows the IEC/IEEE Standard for Binary Floating-Point Arithmetic.
 -------------------------------------------------------------------------------
 */
 static float128
@@ -978,10 +1035,10 @@ static float128
 -------------------------------------------------------------------------------
 Takes an abstract floating-point value having sign `zSign', exponent `zExp',
 and significand formed by the concatenation of `zSig0' and `zSig1', and
-returns the proper quadruple-precision floating-point value corresponding to
-the abstract input.  This routine is just like `roundAndPackFloat128' except
-that the input significand has fewer bits and does not have to be normalized
-in any way.  In all cases, `zExp' must be 1 less than the ``true'' floating-
+returns the proper quadruple-precision floating-point value corresponding
+to the abstract input.  This routine is just like `roundAndPackFloat128'
+except that the input significand has fewer bits and does not have to be
+normalized.  In all cases, `zExp' must be 1 less than the ``true'' floating-
 point exponent.
 -------------------------------------------------------------------------------
 */
@@ -1015,9 +1072,9 @@ static float128
 
 /*
 -------------------------------------------------------------------------------
-Returns the result of converting the 32-bit two's complement integer `a' to
-the single-precision floating-point format.  The conversion is performed
-according to the IEC/IEEE Standard for Binary Floating-point Arithmetic.
+Returns the result of converting the 32-bit two's complement integer `a'
+to the single-precision floating-point format.  The conversion is performed
+according to the IEC/IEEE Standard for Binary Floating-Point Arithmetic.
 -------------------------------------------------------------------------------
 */
 float32 int32_to_float32( int32 a )
@@ -1025,7 +1082,7 @@ float32 int32_to_float32( int32 a )
     flag zSign;
 
     if ( a == 0 ) return 0;
-    if ( a == 0x80000000 ) return packFloat32( 1, 0x9E, 0 );
+    if ( a == (sbits32) 0x80000000 ) return packFloat32( 1, 0x9E, 0 );
     zSign = ( a < 0 );
     return normalizeRoundAndPackFloat32( zSign, 0x9C, zSign ? - a : a );
 
@@ -1033,24 +1090,24 @@ float32 int32_to_float32( int32 a )
 
 /*
 -------------------------------------------------------------------------------
-Returns the result of converting the 32-bit two's complement integer `a' to
-the double-precision floating-point format.  The conversion is performed
-according to the IEC/IEEE Standard for Binary Floating-point Arithmetic.
+Returns the result of converting the 32-bit two's complement integer `a'
+to the double-precision floating-point format.  The conversion is performed
+according to the IEC/IEEE Standard for Binary Floating-Point Arithmetic.
 -------------------------------------------------------------------------------
 */
 float64 int32_to_float64( int32 a )
 {
-    flag aSign;
+    flag zSign;
     uint32 absA;
     int8 shiftCount;
     bits64 zSig;
 
     if ( a == 0 ) return 0;
-    aSign = ( a < 0 );
-    absA = aSign ? - a : a;
+    zSign = ( a < 0 );
+    absA = zSign ? - a : a;
     shiftCount = countLeadingZeros32( absA ) + 21;
     zSig = absA;
-    return packFloat64( aSign, 0x432 - shiftCount, zSig<<shiftCount );
+    return packFloat64( zSign, 0x432 - shiftCount, zSig<<shiftCount );
 
 }
 
@@ -1060,7 +1117,7 @@ float64 int32_to_float64( int32 a )
 -------------------------------------------------------------------------------
 Returns the result of converting the 32-bit two's complement integer `a'
 to the extended double-precision floating-point format.  The conversion
-is performed according to the IEC/IEEE Standard for Binary Floating-point
+is performed according to the IEC/IEEE Standard for Binary Floating-Point
 Arithmetic.
 -------------------------------------------------------------------------------
 */
@@ -1088,7 +1145,7 @@ floatx80 int32_to_floatx80( int32 a )
 -------------------------------------------------------------------------------
 Returns the result of converting the 32-bit two's complement integer `a' to
 the quadruple-precision floating-point format.  The conversion is performed
-according to the IEC/IEEE Standard for Binary Floating-point Arithmetic.
+according to the IEC/IEEE Standard for Binary Floating-Point Arithmetic.
 -------------------------------------------------------------------------------
 */
 float128 int32_to_float128( int32 a )
@@ -1111,9 +1168,127 @@ float128 int32_to_float128( int32 a )
 
 /*
 -------------------------------------------------------------------------------
+Returns the result of converting the 64-bit two's complement integer `a'
+to the single-precision floating-point format.  The conversion is performed
+according to the IEC/IEEE Standard for Binary Floating-Point Arithmetic.
+-------------------------------------------------------------------------------
+*/
+float32 int64_to_float32( int64 a )
+{
+    flag zSign;
+    uint64 absA;
+    int8 shiftCount;
+    bits32 zSig;
+
+    if ( a == 0 ) return 0;
+    zSign = ( a < 0 );
+    absA = zSign ? - a : a;
+    shiftCount = countLeadingZeros64( absA ) - 40;
+    if ( 0 <= shiftCount ) {
+        return packFloat32( zSign, 0x95 - shiftCount, absA<<shiftCount );
+    }
+    else {
+        shiftCount += 7;
+        if ( shiftCount < 0 ) {
+            shift64RightJamming( absA, - shiftCount, &absA );
+        }
+        else {
+            absA <<= shiftCount;
+        }
+        return roundAndPackFloat32( zSign, 0x9C - shiftCount, absA );
+    }
+
+}
+
+/*
+-------------------------------------------------------------------------------
+Returns the result of converting the 64-bit two's complement integer `a'
+to the double-precision floating-point format.  The conversion is performed
+according to the IEC/IEEE Standard for Binary Floating-Point Arithmetic.
+-------------------------------------------------------------------------------
+*/
+float64 int64_to_float64( int64 a )
+{
+    flag zSign;
+
+    if ( a == 0 ) return 0;
+    if ( a == (sbits64) LIT64( 0x8000000000000000 ) ) {
+        return packFloat64( 1, 0x43E, 0 );
+    }
+    zSign = ( a < 0 );
+    return normalizeRoundAndPackFloat64( zSign, 0x43C, zSign ? - a : a );
+
+}
+
+#ifdef FLOATX80
+
+/*
+-------------------------------------------------------------------------------
+Returns the result of converting the 64-bit two's complement integer `a'
+to the extended double-precision floating-point format.  The conversion
+is performed according to the IEC/IEEE Standard for Binary Floating-Point
+Arithmetic.
+-------------------------------------------------------------------------------
+*/
+floatx80 int64_to_floatx80( int64 a )
+{
+    flag zSign;
+    uint64 absA;
+    int8 shiftCount;
+
+    if ( a == 0 ) return packFloatx80( 0, 0, 0 );
+    zSign = ( a < 0 );
+    absA = zSign ? - a : a;
+    shiftCount = countLeadingZeros64( absA );
+    return packFloatx80( zSign, 0x403E - shiftCount, absA<<shiftCount );
+
+}
+
+#endif
+
+#ifdef FLOAT128
+
+/*
+-------------------------------------------------------------------------------
+Returns the result of converting the 64-bit two's complement integer `a' to
+the quadruple-precision floating-point format.  The conversion is performed
+according to the IEC/IEEE Standard for Binary Floating-Point Arithmetic.
+-------------------------------------------------------------------------------
+*/
+float128 int64_to_float128( int64 a )
+{
+    flag zSign;
+    uint64 absA;
+    int8 shiftCount;
+    int32 zExp;
+    bits64 zSig0, zSig1;
+
+    if ( a == 0 ) return packFloat128( 0, 0, 0, 0 );
+    zSign = ( a < 0 );
+    absA = zSign ? - a : a;
+    shiftCount = countLeadingZeros64( absA ) + 49;
+    zExp = 0x406E - shiftCount;
+    if ( 64 <= shiftCount ) {
+        zSig1 = 0;
+        zSig0 = absA;
+        shiftCount -= 64;
+    }
+    else {
+        zSig1 = absA;
+        zSig0 = 0;
+    }
+    shortShift128Left( zSig0, zSig1, shiftCount, &zSig0, &zSig1 );
+    return packFloat128( zSign, zExp, zSig0, zSig1 );
+
+}
+
+#endif
+
+/*
+-------------------------------------------------------------------------------
 Returns the result of converting the single-precision floating-point value
 `a' to the 32-bit two's complement integer format.  The conversion is
-performed according to the IEC/IEEE Standard for Binary Floating-point
+performed according to the IEC/IEEE Standard for Binary Floating-Point
 Arithmetic---which means in particular that the conversion is rounded
 according to the current rounding mode.  If `a' is a NaN, the largest
 positive integer is returned.  Otherwise, if the conversion overflows, the
@@ -1125,18 +1300,18 @@ int32 float32_to_int32( float32 a )
     flag aSign;
     int16 aExp, shiftCount;
     bits32 aSig;
-    bits64 zSig;
+    bits64 aSig64;
 
     aSig = extractFloat32Frac( a );
     aExp = extractFloat32Exp( a );
     aSign = extractFloat32Sign( a );
-    if ( ( aExp == 0x7FF ) && aSig ) aSign = 0;
+    if ( ( aExp == 0xFF ) && aSig ) aSign = 0;
     if ( aExp ) aSig |= 0x00800000;
     shiftCount = 0xAF - aExp;
-    zSig = aSig;
-    zSig <<= 32;
-    if ( 0 < shiftCount ) shift64RightJamming( zSig, shiftCount, &zSig );
-    return roundAndPackInt32( aSign, zSig );
+    aSig64 = aSig;
+    aSig64 <<= 32;
+    if ( 0 < shiftCount ) shift64RightJamming( aSig64, shiftCount, &aSig64 );
+    return roundAndPackInt32( aSign, aSig64 );
 
 }
 
@@ -1144,10 +1319,10 @@ int32 float32_to_int32( float32 a )
 -------------------------------------------------------------------------------
 Returns the result of converting the single-precision floating-point value
 `a' to the 32-bit two's complement integer format.  The conversion is
-performed according to the IEC/IEEE Standard for Binary Floating-point
-Arithmetic, except that the conversion is always rounded toward zero.  If
-`a' is a NaN, the largest positive integer is returned.  Otherwise, if the
-conversion overflows, the largest integer with the same sign as `a' is
+performed according to the IEC/IEEE Standard for Binary Floating-Point
+Arithmetic, except that the conversion is always rounded toward zero.
+If `a' is a NaN, the largest positive integer is returned.  Otherwise, if
+the conversion overflows, the largest integer with the same sign as `a' is
 returned.
 -------------------------------------------------------------------------------
 */
@@ -1163,10 +1338,11 @@ int32 float32_to_int32_round_to_zero( fl
     aSign = extractFloat32Sign( a );
     shiftCount = aExp - 0x9E;
     if ( 0 <= shiftCount ) {
-        if ( a == 0xCF000000 ) return 0x80000000;
+        if ( a != 0xCF000000 ) {
         float_raise( float_flag_invalid );
         if ( ! aSign || ( ( aExp == 0xFF ) && aSig ) ) return 0x7FFFFFFF;
-        return 0x80000000;
+        }
+        return (sbits32) 0x80000000;
     }
     else if ( aExp <= 0x7E ) {
         if ( aExp | aSig ) float_exception_flags |= float_flag_inexact;
@@ -1177,7 +1353,92 @@ int32 float32_to_int32_round_to_zero( fl
     if ( (bits32) ( aSig<<( shiftCount & 31 ) ) ) {
         float_exception_flags |= float_flag_inexact;
     }
-    return aSign ? - z : z;
+    if ( aSign ) z = - z;
+    return z;
+
+}
+
+/*
+-------------------------------------------------------------------------------
+Returns the result of converting the single-precision floating-point value
+`a' to the 64-bit two's complement integer format.  The conversion is
+performed according to the IEC/IEEE Standard for Binary Floating-Point
+Arithmetic---which means in particular that the conversion is rounded
+according to the current rounding mode.  If `a' is a NaN, the largest
+positive integer is returned.  Otherwise, if the conversion overflows, the
+largest integer with the same sign as `a' is returned.
+-------------------------------------------------------------------------------
+*/
+int64 float32_to_int64( float32 a )
+{
+    flag aSign;
+    int16 aExp, shiftCount;
+    bits32 aSig;
+    bits64 aSig64, aSigExtra;
+
+    aSig = extractFloat32Frac( a );
+    aExp = extractFloat32Exp( a );
+    aSign = extractFloat32Sign( a );
+    shiftCount = 0xBE - aExp;
+    if ( shiftCount < 0 ) {
+        float_raise( float_flag_invalid );
+        if ( ! aSign || ( ( aExp == 0xFF ) && aSig ) ) {
+            return LIT64( 0x7FFFFFFFFFFFFFFF );
+        }
+        return (sbits64) LIT64( 0x8000000000000000 );
+    }
+    if ( aExp ) aSig |= 0x00800000;
+    aSig64 = aSig;
+    aSig64 <<= 40;
+    shift64ExtraRightJamming( aSig64, 0, shiftCount, &aSig64, &aSigExtra );
+    return roundAndPackInt64( aSign, aSig64, aSigExtra );
+
+}
+
+/*
+-------------------------------------------------------------------------------
+Returns the result of converting the single-precision floating-point value
+`a' to the 64-bit two's complement integer format.  The conversion is
+performed according to the IEC/IEEE Standard for Binary Floating-Point
+Arithmetic, except that the conversion is always rounded toward zero.  If
+`a' is a NaN, the largest positive integer is returned.  Otherwise, if the
+conversion overflows, the largest integer with the same sign as `a' is
+returned.
+-------------------------------------------------------------------------------
+*/
+int64 float32_to_int64_round_to_zero( float32 a )
+{
+    flag aSign;
+    int16 aExp, shiftCount;
+    bits32 aSig;
+    bits64 aSig64;
+    int64 z;
+
+    aSig = extractFloat32Frac( a );
+    aExp = extractFloat32Exp( a );
+    aSign = extractFloat32Sign( a );
+    shiftCount = aExp - 0xBE;
+    if ( 0 <= shiftCount ) {
+        if ( a != 0xDF000000 ) {
+            float_raise( float_flag_invalid );
+            if ( ! aSign || ( ( aExp == 0xFF ) && aSig ) ) {
+                return LIT64( 0x7FFFFFFFFFFFFFFF );
+            }
+        }
+        return (sbits64) LIT64( 0x8000000000000000 );
+    }
+    else if ( aExp <= 0x7E ) {
+        if ( aExp | aSig ) float_exception_flags |= float_flag_inexact;
+        return 0;
+    }
+    aSig64 = aSig | 0x00800000;
+    aSig64 <<= 40;
+    z = aSig64>>( - shiftCount );
+    if ( (bits64) ( aSig64<<( shiftCount & 63 ) ) ) {
+        float_exception_flags |= float_flag_inexact;
+    }
+    if ( aSign ) z = - z;
+    return z;
 
 }
 
@@ -1185,7 +1446,7 @@ int32 float32_to_int32_round_to_zero( fl
 -------------------------------------------------------------------------------
 Returns the result of converting the single-precision floating-point value
 `a' to the double-precision floating-point format.  The conversion is
-performed according to the IEC/IEEE Standard for Binary Floating-point
+performed according to the IEC/IEEE Standard for Binary Floating-Point
 Arithmetic.
 -------------------------------------------------------------------------------
 */
@@ -1217,7 +1478,7 @@ float64 float32_to_float64( float32 a )
 -------------------------------------------------------------------------------
 Returns the result of converting the single-precision floating-point value
 `a' to the extended double-precision floating-point format.  The conversion
-is performed according to the IEC/IEEE Standard for Binary Floating-point
+is performed according to the IEC/IEEE Standard for Binary Floating-Point
 Arithmetic.
 -------------------------------------------------------------------------------
 */
@@ -1251,7 +1512,7 @@ floatx80 float32_to_floatx80( float32 a 
 -------------------------------------------------------------------------------
 Returns the result of converting the single-precision floating-point value
 `a' to the double-precision floating-point format.  The conversion is
-performed according to the IEC/IEEE Standard for Binary Floating-point
+performed according to the IEC/IEEE Standard for Binary Floating-Point
 Arithmetic.
 -------------------------------------------------------------------------------
 */
@@ -1284,7 +1545,7 @@ float128 float32_to_float128( float32 a 
 Rounds the single-precision floating-point value `a' to an integer, and
 returns the result as a single-precision floating-point value.  The
 operation is performed according to the IEC/IEEE Standard for Binary
-Floating-point Arithmetic.
+Floating-Point Arithmetic.
 -------------------------------------------------------------------------------
 */
 float32 float32_round_to_int( float32 a )
@@ -1342,10 +1603,10 @@ float32 float32_round_to_int( float32 a 
 /*
 -------------------------------------------------------------------------------
 Returns the result of adding the absolute values of the single-precision
-floating-point values `a' and `b'.  If `zSign' is true, the sum is negated
-before being returned.  `zSign' is ignored if the result is a NaN.  The
-addition is performed according to the IEC/IEEE Standard for Binary
-Floating-point Arithmetic.
+floating-point values `a' and `b'.  If `zSign' is 1, the sum is negated
+before being returned.  `zSign' is ignored if the result is a NaN.
+The addition is performed according to the IEC/IEEE Standard for Binary
+Floating-Point Arithmetic.
 -------------------------------------------------------------------------------
 */
 static float32 addFloat32Sigs( float32 a, float32 b, flag zSign )
@@ -1414,10 +1675,10 @@ static float32 addFloat32Sigs( float32 a
 /*
 -------------------------------------------------------------------------------
 Returns the result of subtracting the absolute values of the single-
-precision floating-point values `a' and `b'.  If `zSign' is true, the
+precision floating-point values `a' and `b'.  If `zSign' is 1, the
 difference is negated before being returned.  `zSign' is ignored if the
 result is a NaN.  The subtraction is performed according to the IEC/IEEE
-Standard for Binary Floating-point Arithmetic.
+Standard for Binary Floating-Point Arithmetic.
 -------------------------------------------------------------------------------
 */
 static float32 subFloat32Sigs( float32 a, float32 b, flag zSign )
@@ -1491,7 +1752,7 @@ static float32 subFloat32Sigs( float32 a
 -------------------------------------------------------------------------------
 Returns the result of adding the single-precision floating-point values `a'
 and `b'.  The operation is performed according to the IEC/IEEE Standard for
-Binary Floating-point Arithmetic.
+Binary Floating-Point Arithmetic.
 -------------------------------------------------------------------------------
 */
 float32 float32_add( float32 a, float32 b )
@@ -1513,7 +1774,7 @@ float32 float32_add( float32 a, float32 
 -------------------------------------------------------------------------------
 Returns the result of subtracting the single-precision floating-point values
 `a' and `b'.  The operation is performed according to the IEC/IEEE Standard
-for Binary Floating-point Arithmetic.
+for Binary Floating-Point Arithmetic.
 -------------------------------------------------------------------------------
 */
 float32 float32_sub( float32 a, float32 b )
